
/*  A Bison parser, made from yaccan.y
 by  GNU Bison version 1.25
  */

#define YYBISON 1  /* Identify Bison output.  */

#define	DOWN_FREQ	258
#define	UP_CHAN_ID	259
#define	NETWORK_ACCESS	260
#define	COS	261
#define	MODEM_CAP	262
#define	VENDOR_ID	263
#define	UPGRADE_FILENAME	264
#define	SNMP_WRITE_ACCESS	265
#define	SNMP_MIB_OBJECT	266
#define	CPE_MAC_ADDR	267
#define	BPI	268
#define	MAX_NUM_CPE	269
#define	UPGRADE_SERVER	270
#define	VENDOR_SPECIFIC_INFO	271
#define	CLASS_ID	272
#define	MAX_DOWN_RATE	273
#define	MAX_UP_RATE	274
#define	UP_CHAN_PRIO	275
#define	MIN_UP_RATE	276
#define	MAX_BURST_SIZE	277
#define	COS_BPI_ENABLE	278
#define	CONCATENATION	279
#define	AUTHORIZE_WAIT_TIMEOUT	280
#define	REAUTHORIZE_WAIT_TIMEOUT	281
#define	AUTHORIZATION_GRACE_TIME	282
#define	OPERATIONAL_WAIT_TIMEOUT	283
#define	REKEY_WAIT_TIMEOUT	284
#define	TEK_GRACE_TIME	285
#define	AUTHORIZE_REJECT_WAIT_TIMEOUT	286
#define	INTEGER	287
#define	OCTET_STRING	288
#define	NULL_OBJ	289
#define	OBJECT_ID	290
#define	IPADDRESS	291
#define	IS	292
#define	OPEN_BRACKET	293
#define	CLOSE_BRACKET	294
#define	SEMICOLON	295
#define	ON	296
#define	OFF	297
#define	ENABLE	298
#define	DISABLE	299
#define	ALLOW	300
#define	DISALLOW	301
#define	NUMBER	302
#define	BYTE	303
#define	STRING	304
#define	IP_ADDR_STRING	305
#define	MAC_ADDR_STRING	306
#define	SNMP_OBJ_ID	307


#line 57 "yaccan.y"
typedef union {
   unsigned long	ulong_val;
   unsigned char	byte_val;
   char			*string_val;
   int			bool_val;
} YYSTYPE;
#line 64 "yaccan.y"


/*-----------------------------------------------------------------------*
 * $Log: yaccan.y,v $
 * Revision 1.2  2000/07/27 16:18:35  petras
 * Bug fix with reallocation of OutputBuffer
 *
 * Revision 1.1  2000/03/01 23:19:38  petras
 * Initial revision.
 *
 *-----------------------------------------------------------------------*/

int yylex(YYSTYPE *yylval);
#include "lexan.h"
#define YYDEBUG 1
#define YYERROR_VERBOSE

void yyerror (const char*);

#include "docas.h"
#include <ctype.h>
#include <stdlib.h>
#include <string.h>

#ifndef YYDEBUG
#define YYDEBUG 1
#endif

#include <stdio.h>

#ifndef __cplusplus
#ifndef __STDC__
#define const
#endif
#endif



#define	YYFINAL		157
#define	YYFLAG		-32768
#define	YYNTBASE	53

#define YYTRANSLATE(x) ((unsigned)(x) <= 307 ? yytranslate[x] : 78)

static const char yytranslate[] = {     0,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     1,     2,     3,     4,     5,
     6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
    16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
    26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
    36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
    46,    47,    48,    49,    50,    51,    52
};

#if YYDEBUG != 0
static const short yyprhs[] = {     0,
     0,     2,     3,     6,    10,    13,    14,    20,    21,    27,
    28,    34,    35,    41,    45,    49,    53,    59,    63,    68,
    73,    77,    81,    85,    88,    92,    95,    96,   100,   104,
   108,   112,   116,   120,   124,   127,   131,   134,   138,   141,
   145,   148,   152,   156,   160,   164,   168,   172,   176,   179,
   183,   186,   192,   194,   196,   199,   202,   205,   207,   210,
   213,   215,   217,   219,   221,   223,   225,   227,   229,   231,
   233,   236,   238
};

static const short yyrhs[] = {    54,
     0,     0,    54,    55,     0,    54,    60,    40,     0,    54,
     1,     0,     0,     6,    38,    56,    61,    39,     0,     0,
     7,    38,    57,    63,    39,     0,     0,    13,    38,    58,
    65,    39,     0,     0,    16,    38,    59,    67,    39,     0,
     3,    37,    74,     0,     4,    37,    74,     0,     5,    37,
    72,     0,     8,    37,    48,    48,    48,     0,     9,    37,
    49,     0,    10,    37,    49,    73,     0,    11,    69,    37,
    71,     0,    12,    37,    77,     0,    14,    37,    74,     0,
    15,    37,    76,     0,    62,    40,     0,    61,    62,    40,
     0,    61,     1,     0,     0,    17,    37,    74,     0,    18,
    37,    74,     0,    19,    37,    74,     0,    20,    37,    74,
     0,    21,    37,    74,     0,    22,    37,    74,     0,    23,
    37,    72,     0,    64,    40,     0,    63,    64,    40,     0,
    63,     1,     0,    24,    37,    72,     0,    66,    40,     0,
    65,    66,    40,     0,    65,     1,     0,    25,    37,    74,
     0,    26,    37,    74,     0,    27,    37,    74,     0,    28,
    37,    74,     0,    29,    37,    74,     0,    30,    37,    74,
     0,    31,    37,    74,     0,    68,    40,     0,    67,    68,
    40,     0,    67,     1,     0,     8,    37,    48,    48,    48,
     0,    70,     0,    52,     0,    32,    74,     0,    33,    49,
     0,    33,    75,     0,    34,     0,    35,    69,     0,    36,
    76,     0,     1,     0,    41,     0,    42,     0,    43,     0,
    44,     0,    45,     0,    46,     0,    47,     0,    48,     0,
    48,     0,    75,    48,     0,    50,     0,    51,     0
};

#endif

#if YYDEBUG != 0
static const short yyrline[] = { 0,
    92,    94,    95,    96,    97,    99,   103,   107,   111,   115,
   119,   123,   127,   132,   151,   168,   175,   183,   200,   203,
   234,   241,   258,   267,   268,   269,   271,   272,   288,   294,
   300,   316,   322,   338,   346,   347,   348,   350,   359,   360,
   361,   363,   379,   395,   411,   427,   443,   459,   467,   468,
   469,   471,   482,   516,   564,   584,   596,   608,   616,   628,
   639,   647,   651,   655,   659,   665,   669,   675,   676,   683,
   698,   717,   747
};
#endif


#if YYDEBUG != 0 || defined (YYERROR_VERBOSE)

static const char * const yytname[] = {   "$","error","$undefined.","DOWN_FREQ",
"UP_CHAN_ID","NETWORK_ACCESS","COS","MODEM_CAP","VENDOR_ID","UPGRADE_FILENAME",
"SNMP_WRITE_ACCESS","SNMP_MIB_OBJECT","CPE_MAC_ADDR","BPI","MAX_NUM_CPE","UPGRADE_SERVER",
"VENDOR_SPECIFIC_INFO","CLASS_ID","MAX_DOWN_RATE","MAX_UP_RATE","UP_CHAN_PRIO",
"MIN_UP_RATE","MAX_BURST_SIZE","COS_BPI_ENABLE","CONCATENATION","AUTHORIZE_WAIT_TIMEOUT",
"REAUTHORIZE_WAIT_TIMEOUT","AUTHORIZATION_GRACE_TIME","OPERATIONAL_WAIT_TIMEOUT",
"REKEY_WAIT_TIMEOUT","TEK_GRACE_TIME","AUTHORIZE_REJECT_WAIT_TIMEOUT","INTEGER",
"OCTET_STRING","NULL_OBJ","OBJECT_ID","IPADDRESS","IS","OPEN_BRACKET","CLOSE_BRACKET",
"SEMICOLON","ON","OFF","ENABLE","DISABLE","ALLOW","DISALLOW","NUMBER","BYTE",
"STRING","IP_ADDR_STRING","MAC_ADDR_STRING","SNMP_OBJ_ID","input","commands",
"group","@1","@2","@3","@4","command","cos_commands","cos_command","modem_cap_commands",
"modem_cap_command","bpi_commands","bpi_command","vendor_specific_info_commands",
"vendor_specific_info_command","snmp_obj_id","pre_snmp_obj_id","snmp_type_value",
"enabled_disabled","allow_disallow","number","byte_sequence","ip_addr","mac_addr", NULL
};
#endif

static const short yyr1[] = {     0,
    53,    54,    54,    54,    54,    56,    55,    57,    55,    58,
    55,    59,    55,    60,    60,    60,    60,    60,    60,    60,
    60,    60,    60,    61,    61,    61,    62,    62,    62,    62,
    62,    62,    62,    62,    63,    63,    63,    64,    65,    65,
    65,    66,    66,    66,    66,    66,    66,    66,    67,    67,
    67,    68,    69,    70,    71,    71,    71,    71,    71,    71,
    71,    72,    72,    72,    72,    73,    73,    74,    74,    75,
    75,    76,    77
};

static const short yyr2[] = {     0,
     1,     0,     2,     3,     2,     0,     5,     0,     5,     0,
     5,     0,     5,     3,     3,     3,     5,     3,     4,     4,
     3,     3,     3,     2,     3,     2,     0,     3,     3,     3,
     3,     3,     3,     3,     2,     3,     2,     3,     2,     3,
     2,     3,     3,     3,     3,     3,     3,     3,     2,     3,
     2,     5,     1,     1,     2,     2,     2,     1,     2,     2,
     1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
     2,     1,     1
};

static const short yydefact[] = {     2,
     0,     5,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     3,     0,     0,     0,
     0,     6,     8,     0,     0,     0,    54,     0,    53,     0,
    10,     0,     0,    12,     4,    68,    69,    14,    15,    62,
    63,    64,    65,    16,    27,     0,     0,    18,     0,     0,
    73,    21,     0,    22,    72,    23,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    66,    67,    19,    61,     0,     0,    58,     0,     0,    20,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,    26,
     7,     0,    24,     0,    37,     9,     0,    35,    17,    55,
    70,    56,    57,    59,    60,     0,     0,     0,     0,     0,
     0,     0,    41,    11,     0,    39,     0,    51,    13,     0,
    49,    28,    29,    30,    31,    32,    33,    34,    25,    38,
    36,    71,    42,    43,    44,    45,    46,    47,    48,    40,
     0,    50,     0,    52,     0,     0,     0
};

static const short yydefgoto[] = {   155,
     1,    17,    45,    46,    53,    57,    18,    65,    66,    68,
    69,    88,    89,    91,    92,    28,    29,    80,    44,    73,
    38,   113,    56,    52
};

static const short yypact[] = {-32768,
    79,-32768,   -27,   -21,   -13,   -12,     4,     6,     8,     9,
    -5,    11,    12,    14,    15,    16,-32768,    13,   -43,   -43,
    -6,-32768,-32768,    20,    21,    22,-32768,    32,-32768,    30,
-32768,   -43,    60,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,    44,    48,    63,-32768,   -37,    24,
-32768,-32768,    78,-32768,-32768,-32768,   104,    76,    77,    80,
    81,    82,    83,    84,     0,    75,    85,    10,    86,    68,
-32768,-32768,-32768,-32768,   -43,   -34,-32768,    -5,    60,-32768,
    87,    88,    90,    91,    92,    93,    94,     2,    95,    96,
     5,    97,   -43,   -43,   -43,   -43,   -43,   -43,    -6,-32768,
-32768,    98,-32768,    -6,-32768,-32768,    99,-32768,-32768,-32768,
-32768,-32768,   100,-32768,-32768,   -43,   -43,   -43,   -43,   -43,
   -43,   -43,-32768,-32768,   101,-32768,   102,-32768,-32768,   103,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
   105,-32768,   106,-32768,   123,   132,-32768
};

static const short yypgoto[] = {-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,    69,-32768,
    72,-32768,    54,-32768,    45,    66,-32768,-32768,   -97,-32768,
   -20,-32768,    67,-32768
};


#define	YYLAST		154


static const short yytable[] = {    39,
   100,   138,   123,    36,    37,   128,   140,    71,    72,    19,
   105,    54,    90,   111,   112,    20,    58,    59,    60,    61,
    62,    63,    64,    21,    74,    22,    81,    82,    83,    84,
    85,    86,    87,    67,    40,    41,    42,    43,   101,   -27,
   124,    23,    24,   129,    25,    26,    27,    30,   106,    31,
    32,    33,    35,    34,   110,    75,    76,    77,    78,    79,
    58,    59,    60,    61,    62,    63,    64,    47,    50,    48,
    49,    67,   132,   133,   134,   135,   136,   137,    -1,     2,
    51,     3,     4,     5,     6,     7,     8,     9,    10,    11,
    12,    13,    14,    15,    16,   143,   144,   145,   146,   147,
   148,   149,    81,    82,    83,    84,    85,    86,    87,    55,
    70,    90,    93,    94,   103,   109,    95,    96,    97,    98,
    99,   104,   156,   116,   117,   108,   118,   119,   120,   121,
   122,   157,   127,   102,   126,   130,   131,   139,   141,   107,
   150,   125,   152,   114,     0,   115,     0,   142,     0,   151,
     0,     0,   153,   154
};

static const short yycheck[] = {    20,
     1,    99,     1,    47,    48,     1,   104,    45,    46,    37,
     1,    32,     8,    48,    49,    37,    17,    18,    19,    20,
    21,    22,    23,    37,     1,    38,    25,    26,    27,    28,
    29,    30,    31,    24,    41,    42,    43,    44,    39,    40,
    39,    38,    37,    39,    37,    37,    52,    37,    39,    38,
    37,    37,    40,    38,    75,    32,    33,    34,    35,    36,
    17,    18,    19,    20,    21,    22,    23,    48,    37,    49,
    49,    24,    93,    94,    95,    96,    97,    98,     0,     1,
    51,     3,     4,     5,     6,     7,     8,     9,    10,    11,
    12,    13,    14,    15,    16,   116,   117,   118,   119,   120,
   121,   122,    25,    26,    27,    28,    29,    30,    31,    50,
    48,     8,    37,    37,    40,    48,    37,    37,    37,    37,
    37,    37,     0,    37,    37,    40,    37,    37,    37,    37,
    37,     0,    37,    65,    40,    91,    40,    40,    40,    68,
    40,    88,    40,    78,    -1,    79,    -1,    48,    -1,    48,
    -1,    -1,    48,    48
};
#define YYPURE 1

/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */
#line 3 "/usr/share/bison.simple"

/* Skeleton output parser for bison,
   Copyright (C) 1984, 1989, 1990 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

#ifndef alloca
#ifdef __GNUC__
#define alloca __builtin_alloca
#else /* not GNU C.  */
#if (!defined (__STDC__) && defined (sparc)) || defined (__sparc__) || defined (__sparc) || defined (__sgi)
#include <alloca.h>
#else /* not sparc */
#if defined (MSDOS) && !defined (__TURBOC__)
#include <malloc.h>
#else /* not MSDOS, or __TURBOC__ */
#if defined(_AIX)
#include <malloc.h>
 #pragma alloca
#else /* not MSDOS, __TURBOC__, or _AIX */
#ifdef __hpux
#ifdef __cplusplus
extern "C" {
void *alloca (unsigned int);
};
#else /* not __cplusplus */
void *alloca ();
#endif /* not __cplusplus */
#endif /* __hpux */
#endif /* not _AIX */
#endif /* not MSDOS, or __TURBOC__ */
#endif /* not sparc.  */
#endif /* not GNU C.  */
#endif /* alloca not defined.  */

/* This is the parser code that is written into each bison parser
  when the %semantic_parser declaration is not specified in the grammar.
  It was written by Richard Stallman by simplifying the hairy parser
  used when %semantic_parser is specified.  */

/* Note: there must be only one dollar sign in this file.
   It is replaced by the list of actions, each action
   as one case of the switch.  */

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	return(0)
#define YYABORT 	return(1)
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.
   This remains here temporarily to ease the
   transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(token, value) \
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    { yychar = (token), yylval = (value);			\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { yyerror ("syntax error: cannot back up"); YYERROR; }	\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

#ifndef YYPURE
#define YYLEX		yylex()
#endif

#ifdef YYPURE
#ifdef YYLSP_NEEDED
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, &yylloc, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval, &yylloc)
#endif
#else /* not YYLSP_NEEDED */
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval)
#endif
#endif /* not YYLSP_NEEDED */
#endif

/* If nonreentrant, generate the variables here */

#ifndef YYPURE

int	yychar;			/*  the lookahead symbol		*/
YYSTYPE	yylval;			/*  the semantic value of the		*/
				/*  lookahead symbol			*/

#ifdef YYLSP_NEEDED
YYLTYPE yylloc;			/*  location data for the lookahead	*/
				/*  symbol				*/
#endif

int yynerrs;			/*  number of parse errors so far       */
#endif  /* not YYPURE */

#if YYDEBUG != 0
int yydebug;			/*  nonzero means print parse trace	*/
/* Since this is uninitialized, it does not stop multiple parsers
   from coexisting.  */
#endif

/*  YYINITDEPTH indicates the initial size of the parser's stacks	*/

#ifndef	YYINITDEPTH
#define YYINITDEPTH 200
#endif

/*  YYMAXDEPTH is the maximum size the stacks can grow to
    (effective only if the built-in stack extension method is used).  */

#if YYMAXDEPTH == 0
#undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
#define YYMAXDEPTH 10000
#endif

#ifndef YYPARSE_RETURN_TYPE
#define YYPARSE_RETURN_TYPE int
#endif

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
YYPARSE_RETURN_TYPE yyparse (void);
#endif

#if __GNUC__ > 1		/* GNU C and GNU C++ define this.  */
#define __yy_memcpy(TO,FROM,COUNT)	__builtin_memcpy(TO,FROM,COUNT)
#else				/* not GNU C or C++ */
#ifndef __cplusplus

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (to, from, count)
     char *to;
     char *from;
     int count;
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#else /* __cplusplus */

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (char *to, char *from, int count)
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#endif
#endif

#line 196 "/usr/share/bison.simple"

/* The user can define YYPARSE_PARAM as the name of an argument to be passed
   into yyparse.  The argument should have type void *.
   It should actually point to an object.
   Grammar actions can access the variable by casting it
   to the proper pointer type.  */

#ifdef YYPARSE_PARAM
#ifdef __cplusplus
#define YYPARSE_PARAM_ARG void *YYPARSE_PARAM
#define YYPARSE_PARAM_DECL
#else /* not __cplusplus */
#define YYPARSE_PARAM_ARG YYPARSE_PARAM
#define YYPARSE_PARAM_DECL void *YYPARSE_PARAM;
#endif /* not __cplusplus */
#else /* not YYPARSE_PARAM */
#define YYPARSE_PARAM_ARG
#define YYPARSE_PARAM_DECL
#endif /* not YYPARSE_PARAM */

YYPARSE_RETURN_TYPE
yyparse(YYPARSE_PARAM_ARG)
     YYPARSE_PARAM_DECL
{
  register int yystate;
  register int yyn;
  register short *yyssp;
  register YYSTYPE *yyvsp;
  int yyerrstatus;	/*  number of tokens to shift before error messages enabled */
  int yychar1 = 0;		/*  lookahead token as an internal (translated) token number */

  short	yyssa[YYINITDEPTH];	/*  the state stack			*/
  YYSTYPE yyvsa[YYINITDEPTH];	/*  the semantic value stack		*/

  short *yyss = yyssa;		/*  refer to the stacks thru separate pointers */
  YYSTYPE *yyvs = yyvsa;	/*  to allow yyoverflow to reallocate them elsewhere */

#ifdef YYLSP_NEEDED
  YYLTYPE yylsa[YYINITDEPTH];	/*  the location stack			*/
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;

#define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)
#else
#define YYPOPSTACK   (yyvsp--, yyssp--)
#endif

  int yystacksize = YYINITDEPTH;

#ifdef YYPURE
  int yychar;
  YYSTYPE yylval;
  int yynerrs;
#ifdef YYLSP_NEEDED
  YYLTYPE yylloc;
#endif
#endif

  YYSTYPE yyval;		/*  the variable used to return		*/
				/*  semantic values from the action	*/
				/*  routines				*/

  int yylen;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Starting parse\n");
#endif

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss - 1;
  yyvsp = yyvs;
#ifdef YYLSP_NEEDED
  yylsp = yyls;
#endif

/* Push a new state, which is found in  yystate  .  */
/* In all cases, when you get here, the value and location stacks
   have just been pushed. so pushing a state here evens the stacks.  */
yynewstate:

  *++yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Give user a chance to reallocate the stack */
      /* Use copies of these so that the &'s don't force the real ones into memory. */
      YYSTYPE *yyvs1 = yyvs;
      short *yyss1 = yyss;
#ifdef YYLSP_NEEDED
      YYLTYPE *yyls1 = yyls;
#endif

      /* Get the current used size of the three stacks, in elements.  */
      int size = yyssp - yyss + 1;

#ifdef yyoverflow
      /* Each stack pointer address is followed by the size of
	 the data in use in that stack, in bytes.  */
#ifdef YYLSP_NEEDED
      /* This used to be a conditional around just the two extra args,
	 but that might be undefined if yyoverflow is a macro.  */
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yyls1, size * sizeof (*yylsp),
		 &yystacksize);
#else
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yystacksize);
#endif

      yyss = yyss1; yyvs = yyvs1;
#ifdef YYLSP_NEEDED
      yyls = yyls1;
#endif
#else /* no yyoverflow */
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	{
	  yyerror("parser stack overflow");
	  return 2;
	}
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;
      yyss = (short *) alloca (yystacksize * sizeof (*yyssp));
      __yy_memcpy ((char *)yyss, (char *)yyss1, size * sizeof (*yyssp));
      yyvs = (YYSTYPE *) alloca (yystacksize * sizeof (*yyvsp));
      __yy_memcpy ((char *)yyvs, (char *)yyvs1, size * sizeof (*yyvsp));
#ifdef YYLSP_NEEDED
      yyls = (YYLTYPE *) alloca (yystacksize * sizeof (*yylsp));
      __yy_memcpy ((char *)yyls, (char *)yyls1, size * sizeof (*yylsp));
#endif
#endif /* no yyoverflow */

      yyssp = yyss + size - 1;
      yyvsp = yyvs + size - 1;
#ifdef YYLSP_NEEDED
      yylsp = yyls + size - 1;
#endif

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Stack size increased to %d\n", yystacksize);
#endif

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Entering state %d\n", yystate);
#endif

  goto yybackup;
 yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Reading a token: ");
#endif
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Now at end of input.\n");
#endif
    }
  else
    {
      yychar1 = YYTRANSLATE(yychar);

#if YYDEBUG != 0
      if (yydebug)
	{
	  fprintf (stderr, "Next token is %d (%s", yychar, yytname[yychar1]);
	  /* Give the individual parser a way to print the precise meaning
	     of a token, for further debugging info.  */
#ifdef YYPRINT
	  YYPRINT (stderr, yychar, yylval);
#endif
	  fprintf (stderr, ")\n");
	}
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting token %d (%s), ", yychar, yytname[yychar1]);
#endif

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* count tokens shifted since error; after three, turn off error status.  */
  if (yyerrstatus) yyerrstatus--;

  yystate = yyn;
  goto yynewstate;

/* Do the default action for the current state.  */
yydefault:

  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;

/* Do a reduction.  yyn is the number of a rule to reduce with.  */
yyreduce:
  yylen = yyr2[yyn];
  if (yylen > 0)
    yyval = yyvsp[1-yylen]; /* implement default value of the action */

#if YYDEBUG != 0
  if (yydebug)
    {
      int i;

      fprintf (stderr, "Reducing via rule %d (line %d), ",
	       yyn, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (i = yyprhs[yyn]; yyrhs[i] > 0; i++)
	fprintf (stderr, "%s ", yytname[yyrhs[i]]);
      fprintf (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif


  switch (yyn) {

case 6:
#line 100 "yaccan.y"
{
		  StartGroup(4);
		;
    break;}
case 7:
#line 104 "yaccan.y"
{
		  EndGroup(eCMTS_MIC_COS);
		;
    break;}
case 8:
#line 108 "yaccan.y"
{
		  StartGroup(5);
		;
    break;}
case 9:
#line 112 "yaccan.y"
{
		  EndGroup(eCMTS_MIC_NIL);
		;
    break;}
case 10:
#line 116 "yaccan.y"
{
		  StartGroup(17);
		;
    break;}
case 11:
#line 120 "yaccan.y"
{
		  EndGroup(eCMTS_MIC_BPI);
		;
    break;}
case 12:
#line 124 "yaccan.y"
{
		  StartGroup(43);
		;
    break;}
case 13:
#line 128 "yaccan.y"
{
		  EndGroup(eCMTS_MIC_VendorSpecificInfo);
		;
    break;}
case 14:
#line 133 "yaccan.y"
{
		  unsigned long rem = yyvsp[0].ulong_val % 62500;
		  if (rem != 0) {
		    yyerror(NULL);
		    fprintf(
		      stderr, 
		      "down_freq = %lu is not a multiple of 62500 Hz, ",
		      yyvsp[0].ulong_val
		    );
		    yyvsp[0].ulong_val -= rem;
		    fprintf(stderr, "using %lu instead.\n", yyvsp[0].ulong_val);
		    
		  }
		  WriteByte(1); /* type */
		  WriteByte(4); /* length */
		  WriteNumber(yyvsp[0].ulong_val, 4);
		  ReportCMTS_MIC_Data(eCMTS_MIC_DownFreq, NextWritePosition()-6, 6);
		;
    break;}
case 15:
#line 152 "yaccan.y"
{
		  if (yyvsp[0].ulong_val > 0xff) {
		    yyerror(NULL);
		    fprintf(
		      stderr, 
		      "UP_CHAN_ID %lu out of range, valid range is [0..255], ",
		      yyvsp[0].ulong_val
		    );
		    yyvsp[0].ulong_val = 0xff;
		    fprintf(stderr, "using %lu instead.\n", yyvsp[0].ulong_val);
		  }
		  WriteByte(2); /* type */
		  WriteByte(1); /* length */
		  WriteNumber(yyvsp[0].ulong_val, 1);
		  ReportCMTS_MIC_Data(eCMTS_MIC_UpChanId, NextWritePosition()-3, 3);
		;
    break;}
case 16:
#line 169 "yaccan.y"
{
		  WriteByte(3); /* type */
		  WriteByte(1); /* length */
		  WriteNumber(yyvsp[0].bool_val? 1:0, 1);
		  ReportCMTS_MIC_Data(eCMTS_MIC_NetworkAccess, NextWritePosition()-3, 3);
		;
    break;}
case 17:
#line 176 "yaccan.y"
{
		  WriteByte(8); /* type */
		  WriteByte(3); /* length */
		  WriteByte(yyvsp[-2].byte_val); /* byte 1 */
		  WriteByte(yyvsp[-1].byte_val); /* byte 2 */
		  WriteByte(yyvsp[0].byte_val); /* byte 3 */
		;
    break;}
case 18:
#line 184 "yaccan.y"
{
		  char *name = yyvsp[0].string_val;
		  int len = strlen(name);
		  if (len>0xff) {
		    yyerror(NULL);
		    fprintf(
		      stderr, 
		      "upgrade_filename too long, shortening to 255 characters\n"
		    );
		    len=0xff;
		  }
		  WriteByte(9); /* type */
		  WriteByte(len); /* length */
		  WriteString(name, len);
		  free(name);
		;
    break;}
case 19:
#line 201 "yaccan.y"
{
		;
    break;}
case 20:
#line 204 "yaccan.y"
{
		  /* the first char in string snmp_obj_id gives the length */
		  int mib_len_pos;
		  int seq_len_pos;
		  int obj_id_len = (int)yyvsp[-2].string_val[0];
		  byte *obj_id = (byte *)yyvsp[-2].string_val+1;
		  int value_len = (int)yyvsp[0].string_val[0];
		  byte *value = (byte *)yyvsp[0].string_val+1;
		  

		  WriteByte(11); /* type = SNMP MIB Object */
		  mib_len_pos = NextWritePosition();
		  WriteByte(0); /* dummy for SNMP MIB Object length */

		  WriteByte(0x30); /* type = SEQUENCE */
		  seq_len_pos = NextWritePosition();
		  WriteByte(0); /* dummy for SEQUENCE length */

		  WriteByte(0x06); /* type = OBJECT IDENTIFIER */
		  WriteByte(obj_id_len);
		  WriteString(obj_id, obj_id_len);

		  WriteString(value, value_len);

		  WriteByteAtPosition(seq_len_pos, (byte)(NextWritePosition()-seq_len_pos-1));
		  WriteByteAtPosition(mib_len_pos, (byte)(NextWritePosition()-mib_len_pos-1));
 
		  free(yyvsp[-2].string_val);
		  free(yyvsp[0].string_val);
		;
    break;}
case 21:
#line 235 "yaccan.y"
{
		  WriteByte(14); /* type */
		  WriteByte(6); /* length */
		  WriteString(yyvsp[0].string_val, 6);
		  free(yyvsp[0].string_val);
		;
    break;}
case 22:
#line 242 "yaccan.y"
{
		  if (yyvsp[0].ulong_val > 0xff) {
		    yyerror(NULL);
		    fprintf(
		      stderr, 
		      "max_num_cpe %lu out of range, valid range is [0..255], ",
		      yyvsp[0].ulong_val
		    );
		    yyvsp[0].ulong_val = 0xff;
		    fprintf(stderr, "using %lu instead.\n", yyvsp[0].ulong_val);
		  }
		  WriteByte(18); /* type */
		  WriteByte(1); /* length */
		  WriteNumber(yyvsp[0].ulong_val, 1);
		  ReportCMTS_MIC_Data(eCMTS_MIC_MaxNumCpe, NextWritePosition()-3, 3);
		;
    break;}
case 23:
#line 259 "yaccan.y"
{
		  WriteByte(21); /* type */
		  WriteByte(4); /* length */
		  WriteString(yyvsp[0].string_val, 4);
		  free(yyvsp[0].string_val);
		;
    break;}
case 28:
#line 273 "yaccan.y"
{
		  if (yyvsp[0].ulong_val<1 || yyvsp[0].ulong_val>16) {
		    yyerror(NULL);
		    fprintf(
		      stderr, 
		      "class_id %lu out of range, valid range is [1..16], ",
		      yyvsp[0].ulong_val
		    );
		    yyvsp[0].ulong_val = 16;
		    fprintf(stderr, "using %lu instead.\n", yyvsp[0].ulong_val);
		  }
		  WriteByte(1); /* type */
		  WriteByte(1); /* length */
		  WriteNumber(yyvsp[0].ulong_val, 1);
		;
    break;}
case 29:
#line 289 "yaccan.y"
{
		  WriteByte(2); /* type */
		  WriteByte(4); /* length */
		  WriteNumber(yyvsp[0].ulong_val, 4);
		;
    break;}
case 30:
#line 295 "yaccan.y"
{
		  WriteByte(3); /* type */
		  WriteByte(4); /* length */
		  WriteNumber(yyvsp[0].ulong_val, 4);
		;
    break;}
case 31:
#line 301 "yaccan.y"
{
		  if (yyvsp[0].ulong_val>7) {
		    yyerror(NULL);
		    fprintf(
		      stderr, 
		      "up_chan_prio %lu out of range, valid range is [0..7], ",
		      yyvsp[0].ulong_val
		    );
		    yyvsp[0].ulong_val = 7;
		    fprintf(stderr, "using %lu instead.\n", yyvsp[0].ulong_val);
		  }
		  WriteByte(4); /* type */
		  WriteByte(1); /* length */
		  WriteNumber(yyvsp[0].ulong_val, 1);
		;
    break;}
case 32:
#line 317 "yaccan.y"
{
		  WriteByte(5); /* type */
		  WriteByte(4); /* length */
		  WriteNumber(yyvsp[0].ulong_val, 4);
		;
    break;}
case 33:
#line 323 "yaccan.y"
{
		  if (yyvsp[0].ulong_val > 1518) {
		    yyerror(NULL);
		    fprintf(
		      stderr, 
		      "max_burst_size %lu out of range, valid range is [0..1518], ",
		      yyvsp[0].ulong_val
		    );
		    yyvsp[0].ulong_val = 1518;
		    fprintf(stderr, "using %lu instead.\n", yyvsp[0].ulong_val);
		  }
		  WriteByte(6); /* type */
		  WriteByte(2); /* length */
		  WriteNumber(yyvsp[0].ulong_val, 2);
		;
    break;}
case 34:
#line 339 "yaccan.y"
{
		  WriteByte(7); /* type */
		  WriteByte(1); /* length */
		  WriteNumber(yyvsp[0].bool_val? 1:0, 1);
		;
    break;}
case 38:
#line 352 "yaccan.y"
{
		  WriteByte(1); /* type */
		  WriteByte(1); /* length */
		  WriteNumber(yyvsp[0].bool_val? 1:0, 1);
		;
    break;}
case 42:
#line 364 "yaccan.y"
{
		  if (yyvsp[0].ulong_val<1 || yyvsp[0].ulong_val>30) {
		    yyerror(NULL);
		    fprintf(
		      stderr, 
		      "authorize_wait_timeout %lu out of range, valid range is [1..30], ",
		      yyvsp[0].ulong_val
		    );
		    yyvsp[0].ulong_val = 30;
		    fprintf(stderr, "using %lu instead.\n", yyvsp[0].ulong_val);
		  }
		  WriteByte(1); /* type */
		  WriteByte(4); /* length */
		  WriteNumber(yyvsp[0].ulong_val, 4);
		;
    break;}
case 43:
#line 380 "yaccan.y"
{
		  if (yyvsp[0].ulong_val<1 || yyvsp[0].ulong_val>20) {
		    yyerror(NULL);
		    fprintf(
		      stderr, 
		      "reauthorize_wait_timeout %lu out of range, valid range is [1..20], ",
		      yyvsp[0].ulong_val
		    );
		    yyvsp[0].ulong_val = 20;
		    fprintf(stderr, "using %lu instead.\n", yyvsp[0].ulong_val);
		  }
		  WriteByte(2); /* type */
		  WriteByte(4); /* length */
		  WriteNumber(yyvsp[0].ulong_val, 4);
		;
    break;}
case 44:
#line 396 "yaccan.y"
{
		  if (yyvsp[0].ulong_val<1 || yyvsp[0].ulong_val>1800) {
		    yyerror(NULL);
		    fprintf(
		      stderr, 
		      "authorization_grace_time %lu out of range, valid range is [1..1800], ",
		      yyvsp[0].ulong_val
		    );
		    yyvsp[0].ulong_val = 1800;
		    fprintf(stderr, "using %lu instead.\n", yyvsp[0].ulong_val);
		  }
		  WriteByte(3); /* type */
		  WriteByte(4); /* length */
		  WriteNumber(yyvsp[0].ulong_val, 4);
		;
    break;}
case 45:
#line 412 "yaccan.y"
{
		  if (yyvsp[0].ulong_val<1 || yyvsp[0].ulong_val>10) {
		    yyerror(NULL);
		    fprintf(
		      stderr, 
		      "operational_wait_timeout %lu out of range, valid range is [1..10], ",
		      yyvsp[0].ulong_val
		    );
		    yyvsp[0].ulong_val = 10;
		    fprintf(stderr, "using %lu instead.\n", yyvsp[0].ulong_val);
		  }
		  WriteByte(4); /* type */
		  WriteByte(4); /* length */
		  WriteNumber(yyvsp[0].ulong_val, 4);
		;
    break;}
case 46:
#line 428 "yaccan.y"
{
		  if (yyvsp[0].ulong_val<1 || yyvsp[0].ulong_val>10) {
		    yyerror(NULL);
		    fprintf(
		      stderr, 
		      "rekey_wait_timeout %lu out of range, valid range is [1..10], ",
		      yyvsp[0].ulong_val
		    );
		    yyvsp[0].ulong_val = 10;
		    fprintf(stderr, "using %lu instead.\n", yyvsp[0].ulong_val);
		  }
		  WriteByte(5); /* type */
		  WriteByte(4); /* length */
		  WriteNumber(yyvsp[0].ulong_val, 4);
		;
    break;}
case 47:
#line 444 "yaccan.y"
{
		  if (yyvsp[0].ulong_val<1 || yyvsp[0].ulong_val>1800) {
		    yyerror(NULL);
		    fprintf(
		      stderr, 
		      "tek_grace_time %lu out of range, valid range is [1..1800], ",
		      yyvsp[0].ulong_val
		    );
		    yyvsp[0].ulong_val = 1800;
		    fprintf(stderr, "using %lu instead.\n", yyvsp[0].ulong_val);
		  }
		  WriteByte(6); /* type */
		  WriteByte(4); /* length */
		  WriteNumber(yyvsp[0].ulong_val, 4);
		;
    break;}
case 48:
#line 460 "yaccan.y"
{
		  WriteByte(7); /* type */
		  WriteByte(4); /* length */
		  WriteNumber(yyvsp[0].ulong_val, 4);
		;
    break;}
case 52:
#line 473 "yaccan.y"
{
		  WriteByte(8); /* type */
		  WriteByte(3); /* length */
		  WriteByte(yyvsp[-2].byte_val);
		  WriteByte(yyvsp[-1].byte_val);
		  WriteByte(yyvsp[0].byte_val);
		;
    break;}
case 53:
#line 483 "yaccan.y"
{
		  /* Now I can correct the encoding of the first two sub_obj_ids. */
		  /* The first char in string snmp_obj_id gives the length */
		  int obj_id_len = (int)yyvsp[0].string_val[0];
		  byte *obj_id = (byte *)yyvsp[0].string_val+1;
		  if (obj_id[0] > 2) {
		    yyerror(NULL);
		    fprintf(
		      stderr, 
		      "illegal value %d of first sub-identifier in SNMP Object Id, valid range is [1..3], ",
		      (int)obj_id[0]
		    );
		    obj_id[0] = 1;
		  }
		  if (obj_id[1] > 39) {
		    yyerror(NULL);
		    fprintf(
		      stderr, 
		      "illegal value %d of first sub-identifier in SNMP Object Id, valid range is [1..39], ",
		      (int)obj_id[1]
		    );
		    obj_id[1] = 39;
		  }
		  obj_id[1] = obj_id[0]*40 + obj_id[1];
		  obj_id_len--;
		  /* shift sequence one byte to the left */
		  memmove(obj_id, obj_id+1, obj_id_len);
		  /* write back new length */
		  obj_id[-1] = obj_id_len;
		  yyval.string_val = yyvsp[0].string_val;
		;
    break;}
case 54:
#line 517 "yaccan.y"
{
		  /* we return a string with its length being encoded in
		     its first char */
		  /* Correct of the encoding of the first two sub_obj_ids
		     is done by snmp_obj_id */
		  int in_cnt = 0;
		  int out_cnt = 1;
		  char *input = yyvsp[0].string_val;
		  byte *buffer = (byte*)malloc(strlen(input)*3+4);

		  while (1) {
		    unsigned long su_obj_id = 0;
		    char c;

		    /* read the next integer */
		    while (1) {
		      c = input[in_cnt++];
		      if (c=='\0' || c=='.') break;
		      su_obj_id = su_obj_id*10 + c-'0';
		    }

		    /* write it to buffer */
		    if (su_obj_id>0x0fffffff) buffer[out_cnt++] =
						(byte)((su_obj_id>>28 & 0x7f) | 0x80);
		    if (su_obj_id>0x001fffff) buffer[out_cnt++] =
						(byte)((su_obj_id>>21 & 0x7f) | 0x80);
		    if (su_obj_id>0x00003fff) buffer[out_cnt++] =
						(byte)((su_obj_id>>14 & 0x7f) | 0x80);
		    if (su_obj_id>0x0000007f) buffer[out_cnt++] =
						(byte)((su_obj_id>>7  & 0x7f) | 0x80);
		    if (1                   ) buffer[out_cnt++] =
						(byte)((su_obj_id     & 0x7f)       );

		    if (c=='\0') break; 
		    if (c!='.') {
		      yyerror(NULL);
		      fprintf(stderr,"syntax SNMP object identifier `%s'", input);
		      break;
		    }
		  }
		  buffer[0] = out_cnt-1;
		  yyval.string_val = buffer;

		  free(input);
		;
    break;}
case 55:
#line 565 "yaccan.y"
{
		  /* return type is a non-null-terminated string with the
		   * first char giving its length.
		   * This item is only for positiv numbers!!!
		   */
		  unsigned int val = yyvsp[0].ulong_val;
		  int out_cnt = 1;
		  byte *buffer = (byte*)malloc(7);

		  buffer[out_cnt++] = 0x02; /* type = INTEGER */
		  buffer[out_cnt++] = 0; /* value length will be filled in later */
		  if (val>0x007fffff) buffer[out_cnt++] = (byte)(val>>24 & 0xff);
		  if (val>0x00007fff) buffer[out_cnt++] = (byte)(val>>16 & 0xff);
		  if (val>0x0000007f) buffer[out_cnt++] = (byte)(val>> 8 & 0xff);
		  if (1             ) buffer[out_cnt++] = (byte)(val     & 0xff);
		  buffer[2] = out_cnt-3; /* value length */
		  buffer[0] = out_cnt-1; /* string length */
		  yyval.string_val = buffer;
		;
    break;}
case 56:
#line 585 "yaccan.y"
{
		  int len = strlen(yyvsp[0].string_val);
		  byte *buffer = (byte*)malloc(len+3);

		  buffer[0] = len+2; /* string length */
		  buffer[1] = 0x04; /* type = OCTET STRING */
		  buffer[2] = len;  /* value length */
		  memcpy(buffer+3, yyvsp[0].string_val, len);
		  free(yyvsp[0].string_val);
		  yyval.string_val = buffer;
		;
    break;}
case 57:
#line 597 "yaccan.y"
{
		  int len = yyvsp[0].string_val[0];
		  byte *buffer = (byte*)malloc(len+3);

		  buffer[0] = len+2; /* string length */
		  buffer[1] = 0x04; /* type = OCTET STRING */
		  buffer[2] = len;  /* value length */
		  memcpy(buffer+3, yyvsp[0].string_val+1, len);
		  free(yyvsp[0].string_val);
		  yyval.string_val = buffer;
		;
    break;}
case 58:
#line 609 "yaccan.y"
{
		  byte *buffer = (byte*)malloc(3);
		  buffer[0] = 2;    /* string length */
		  buffer[1] = 0x05; /* type = NULL */
		  buffer[2] = 0;    /* value length */
		  yyval.string_val = buffer;
		;
    break;}
case 59:
#line 617 "yaccan.y"
{
		  int len = yyvsp[0].string_val[0];
		  byte *buffer = (byte*)malloc(len+3);

		  buffer[0] = len+2; /* string length */
		  buffer[1] = 0x06; /* type = OBJECT ID */
		  buffer[2] = len;  /* value length */
		  memcpy(buffer+3, yyvsp[0].string_val+1, len);
		  free(yyvsp[0].string_val);
		  yyval.string_val = buffer;
		;
    break;}
case 60:
#line 629 "yaccan.y"
{
		  byte *buffer = (byte*)malloc(7);

		  buffer[0] = 6; /* string length */
		  buffer[1] = 0x40; /* type = IpAddress */
		  buffer[2] = 4;  /* value length */
		  memcpy(buffer+3, yyvsp[0].string_val, 4);
		  free(yyvsp[0].string_val);
		  yyval.string_val = buffer;
		;
    break;}
case 61:
#line 640 "yaccan.y"
{
		  byte *buffer = (byte*)malloc(1);
		  buffer[0] = 0;
		  yyval.string_val = buffer;
		;
    break;}
case 62:
#line 648 "yaccan.y"
{
		  yyval.bool_val = 1;
		;
    break;}
case 63:
#line 652 "yaccan.y"
{
		  yyval.bool_val = 0;
		;
    break;}
case 64:
#line 656 "yaccan.y"
{
		  yyval.bool_val = 1;
		;
    break;}
case 65:
#line 660 "yaccan.y"
{
		  yyval.bool_val = 0;
		;
    break;}
case 66:
#line 666 "yaccan.y"
{
		  yyval.bool_val = 1;
		;
    break;}
case 67:
#line 670 "yaccan.y"
{
		  yyval.bool_val = 0;
		;
    break;}
case 69:
#line 677 "yaccan.y"
{
		  unsigned char c = yyvsp[0].byte_val;
		  yyval.ulong_val = (unsigned long)c;
		;
    break;}
case 70:
#line 684 "yaccan.y"
{
		  /* The first byte of the sequence gives its length.
		   * The length of the malloc block is always n*8+1
		   * Thus, sequence[0]==5 -> malloc(9)
		   *       sequence[0]==8 -> malloc(9)
		   *       sequence[0]==9 -> malloc(17)
		   *       etc.
		   */
		  byte *sequence = (byte *)malloc(9);
		  sequence[0] = 1;
		  sequence[1] = yyvsp[0].byte_val;
		  yyval.string_val = sequence;
		;
    break;}
case 71:
#line 699 "yaccan.y"
{
		  byte *sequence = (byte *)yyvsp[-1].string_val;
		  int len = sequence[0];
		  if (len%8 == 0) {
		    /* no more free bytes in malloc block, */
		    /* have to extend it by 8 byte */
		    int new_len = len+9;
		    byte *new_seq = (byte *)malloc(new_len);
		    memcpy(new_seq, sequence, len+1);
		    free(sequence);
		    sequence = new_seq;
		  }
		  sequence[0] = len+1;
		  sequence[len+1] = yyvsp[0].byte_val;
		  yyval.string_val = sequence;
		;
    break;}
case 72:
#line 718 "yaccan.y"
{
		  int byte_cnt;
		  int char_cnt = 0;
		  char *ip_addr = (char *)malloc(4);

		  for (byte_cnt=0; byte_cnt<4; byte_cnt++) {
		    int b = 0;
		    while (1) {
		      char c = yyvsp[0].string_val[char_cnt];
		      if (c=='\0' || c=='.') break;
		      b = b*10 + c-'0';
		      char_cnt++;
		    }
		    if (b > 0xff) {
		      int i;
		      yyerror(NULL);
		      fprintf(stderr,"syntax error in IP address string `%s'", yyvsp[0].string_val);
		      /* reset ip_addr */
		      for(i=0; i<4;i++) ip_addr[i] = 0;
		      break;
		    }
		    ip_addr[byte_cnt] = (char)b;
		    char_cnt++; /* jump over '.' */
		  }
		  yyval.string_val = ip_addr;
		  free(yyvsp[0].string_val);
		;
    break;}
case 73:
#line 748 "yaccan.y"
{
		  int byte_cnt;
		  int char_cnt = 0;
		  char *mac_addr = (char *)malloc(6);

		  for (byte_cnt=0; byte_cnt<6; byte_cnt++) {
		    int b = 0;
		    while (1) {
		      char c = yyvsp[0].string_val[char_cnt];
		      if (c=='\0' || c==':') break;
		      if (c>='0' && c<='9') c -= '0';
		      else if (isalpha(c))  c = toupper(c) - 'A' + 10;
		      b = b*16 + c;
		      char_cnt++;
		    }
		    mac_addr[byte_cnt] = (char)b;
		    char_cnt++; /* jump over ':' */
		  }
		  yyval.string_val = mac_addr;
		;
    break;}
}
   /* the action file gets copied in in place of this dollarsign */
#line 498 "/usr/share/bison.simple"

  yyvsp -= yylen;
  yyssp -= yylen;
#ifdef YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;

#ifdef YYLSP_NEEDED
  yylsp++;
  if (yylen == 0)
    {
      yylsp->first_line = yylloc.first_line;
      yylsp->first_column = yylloc.first_column;
      yylsp->last_line = (yylsp-1)->last_line;
      yylsp->last_column = (yylsp-1)->last_column;
      yylsp->text = 0;
    }
  else
    {
      yylsp->last_line = (yylsp+yylen-1)->last_line;
      yylsp->last_column = (yylsp+yylen-1)->last_column;
    }
#endif

  /* Now "shift" the result of the reduction.
     Determine what state that goes to,
     based on the state we popped back to
     and the rule number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;

yyerrlab:   /* here on detecting error */

  if (! yyerrstatus)
    /* If not already recovering from an error, report this error.  */
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  int size = 0;
	  char *msg;
	  int x, count;

	  count = 0;
	  /* Start X at -yyn if nec to avoid negative indexes in yycheck.  */
	  for (x = (yyn < 0 ? -yyn : 0);
	       x < (sizeof(yytname) / sizeof(char *)); x++)
	    if (yycheck[x + yyn] == x)
	      size += strlen(yytname[x]) + 15, count++;
	  msg = (char *) malloc(size + 15);
	  if (msg != 0)
	    {
	      strcpy(msg, "parse error");

	      if (count < 5)
		{
		  count = 0;
		  for (x = (yyn < 0 ? -yyn : 0);
		       x < (sizeof(yytname) / sizeof(char *)); x++)
		    if (yycheck[x + yyn] == x)
		      {
			strcat(msg, count == 0 ? ", expecting `" : " or `");
			strcat(msg, yytname[x]);
			strcat(msg, "'");
			count++;
		      }
		}
	      yyerror(msg);
	      free(msg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exceeded");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror("parse error");
    }

  goto yyerrlab1;
yyerrlab1:   /* here on error raised explicitly by an action */

  if (yyerrstatus == 3)
    {
      /* if just tried and failed to reuse lookahead token after an error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Discarding token %d (%s).\n", yychar, yytname[yychar1]);
#endif

      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token
     after shifting the error token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;

yyerrdefault:  /* current state does not do anything special for the error token. */

#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */
  yyn = yydefact[yystate];  /* If its default is to accept any token, ok.  Otherwise pop it.*/
  if (yyn) goto yydefault;
#endif

yyerrpop:   /* pop the current state because it cannot handle the error token */

  if (yyssp == yyss) YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#ifdef YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "Error: state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

yyerrhandle:

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting error token, ");
#endif

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;
}
#line 770 "yaccan.y"


  void yyerror (const char* s)  {
    fprintf (stderr, "%s:%d: ", YYSourceName, YYLineNo);
    if (s) fprintf(stderr, "%s\n", s);
  }


/* {{{ Local variables */

/*
  Local variables:
  folded-file: t
  c-basic-offset: 2
  End:
*/

/* }}} */
